<table>
<thead>
<tr>
  <th>番組名</th>
  <th>放送局</th>
  <th>時間</th>
  <th>概要</th>
</tr>
</thead>
<?php

// フィードURI
// 神奈川県で視聴可能なバラエティとニュースを取得する
$base_uri = 'http://tv.livedoor.com/rss/search?genre_code=G1&genre_code=IA&genre_code=JA&genre_code=JB&genre_code=KH&pref_id=14';

// tvとdc名前空間
define('NS_TV', 'http://tv.livedoor.com/spec/-/1.0/');
define('NS_DC', 'http://purl.org/dc/elements/1.1/');

// フィードの解析をする
$simple_xml = simplexml_load_file($base_uri);

// テレビ番組を一つずつ表示する
foreach ($simple_xml->item as $item) {
  // 各名前空間の要素を抽出する
  $tv = $item->children(NS_TV);
  $dc = $item->children(NS_DC);

  // 番組の開始時間と終了時間をUNIXタイムへ変換する
  $startDatetime = strtotime($tv->feed->startDatetime);
  $endDatetime = strtotime($tv->feed->endDatetime);
?>
<tr>
  <td><?php echo $item->title; ?></td>
  <td><?php echo $dc->publisher; ?></td>
  <td><?php echo strftime('%Y-%m-%d %H:%M', $startDatetime) . '-' . strftime('%H:%M', $endDatetime); ?></td>
  <td><?php echo $item->description; ?></td>
</tr>
<?php
}

?>
</table>
