<html>
<head>
<title>Webページの使用言語を判定</title>
</head>
<body>
<h1>Webページの使用言語を判定
<!-- begin: Attributing TRYNT -->
<a href="http://www.trynt.com/" title="TRYNT Web Services">
<img src="http://images.trynt.com/trynt-powered.png" border="0" title="TRYNT Web Services">
</a>
<!-- end: Attributing TRYNT -->
</h1>
<?php

require_once 'HTTP/Request.php';

// 入力する変数の設定
// $targetUrl: 対象とするWebページのURL
// デフォルトはL'internaute (フランス語)
if(isset($_REQUEST['targetUrl'])){
  $targetUrl = $_REQUEST['targetUrl'];
}else{
  $targetUrl= "http://www.linternaute.com/";
}

// 入力フォームの表示
$action = $_SERVER['PHP_SELF'];
echo <<<EOP
<form action="$action" method="get">
<p>
<input type="text" name="targetUrl" value="$targetUrl" size="80">
<input type="submit" >
</p>
</form>
EOP;

// $targetUrlから本文($targetBody)を取得
// fgetss関数でタグを取り除く
$f = fopen($targetUrl, "r") or die("targetUrl open error");
$targetBody = "";
while(!feof($f)){
  $targetBody .= fgetss($f);
}

// $targetBodyの言語を判定
// もっともポイントの高い言語($language)を取得
// TRYNT Language Identification Web Serviceを使用
// POSTでデータを送信
$language = "";
$req = new HTTP_Request();
$req->setURL("http://www.trynt.com/language-identification-api/v1/");
$req->setMethod(HTTP_REQUEST_METHOD_POST);
$req->addPostData('s', $targetBody);

if (!PEAR::isError($req->sendRequest())) {
  $response = $req->getResponseBody();
  $doc = new SimpleXMLElement($response);
  foreach($doc as $language => $point){
    break; //最高ポイントの要素は先頭にある
  }
 } else {
  die("Trynt Language API Request Error");
}

// $languageの表示
print "<p><a href=\"$targetUrl\">$targetUrl</a>の使用言語はおそらく<strong>$language</strong>です。</p>\n";
?>
</body>
</html>
