<html>
<head>
<title>相性順に並べ替え</title>
</head>
<body>
<h1>相性順に並べ替え
<!-- begin: Attributing TRYNT -->
<a href="http://www.trynt.com/" title="TRYNT Web Services">
<img src="http://images.trynt.com/trynt-powered.png" border="0" title="TRYNT Web Services">
</a>
<!-- end: Attributing TRYNT -->
</h1>
<?php
// -----------------------
// 入力する変数の設定
// -----------------------
// $myName: 私の名前
// デフォルトはtakayuki
if(isset($_REQUEST['myName'])){
  $myName = $_REQUEST['myName'];
}else{
  $myName = "takayuki";
}

// $loversCsv: 愛人の名前のリスト, カンマ区切りの文字列
// デフォルトは5人の名前
if(isset($_REQUEST['loversCsv'])){
  $loversCsv = $_REQUEST['loversCsv'];
}else{
  $loversCsv = "ayumi,hitomi,yuki,sakura,hanako";
}

// -----------------------
// 入力フォームの表示
// -----------------------
$action = $_SERVER['PHP_SELF'];
echo <<<EOP
<form action="$action" method="get">
<p>
<input type="text" name="myName" value="$myName">
<span style="color:red;font-size:large">&hearts;</span>
<input type="text" name="loversCsv" value="$loversCsv" size="40">
<input type="submit" >
</p>
</form>
EOP;

// -----------------------
// 愛人データ$loversの構築
// -----------------------
// 愛人Loverクラス
class Lover {
  var $name, $matching;
  function Lover($name, $matching)
  {
    $this->name = $name;
    $this->matching = $matching;
  }
}

// 相性の計算
// TRYNT Love Calculator Web Serviceを使用
function calculateMatching($name1, $name2)
{
  // リクエストの作成
  $req = "http://www.trynt.com/love-calculator-api/v1/?";
  $req .= "a=$name1&";
  $req .= "b=$name2";

  // レスポンスから相性を取得して返す
  $res = simplexml_load_file($req) or die("Love API NULL response");
  return $res->{'Love-Calculator'}->results->lover;
}

// $lovers: Loverクラスのインスタンスのリスト
$lovers = array();
foreach (split(',', $loversCsv) as $name) {
  $matching = calculateMatching($name, $myName);
  $lovers[] =  new Lover($name, $matching);
}

// -----------------------
// 並び替え
// -----------------------
function compareByMatching($lover1, $lover2)
{
  return ($lover1->matching < $lover2->matching);
}

usort($lovers, "compareByMatching");

// -----------------------
// $loversの表示
// -----------------------
print "<ol>\n";
foreach ($lovers as $lover) {
  print "<li>$lover->name ($lover->matching)</li>";
}
print "</ol>\n";

?>
</body>
</html>
