<?php

// ログインURIを取得する
function getLoginURI($next, $scope, $secure = 0, $session = 0)
{
  // APIベースURI
  $base_uri = 'https://www.google.com/accounts/AuthSubRequest';

  // 引数リスト
  $args = array(
    'next' => urlencode($next),
    'scope' => urlencode($scope),
    'secure' => (string)$secure,
    'session' => (string)$session,
  );

  // キー・値ペア文字列を生成する
  $param = array();
  foreach ($args as $key => $val) {
    $param[] = "{$key}={$val}";
  }

  // URIを返す
  return $base_uri . '?' . implode('&amp;', $param);
}

?>
<a href="<?php echo getLoginURI('http://www.example.net/callback.php', 'http://www.google.com/calendar/feeds/'); ?>">Googleの認証ページ</a>へ移動し、ログインしてください。
